using System;
using System.Linq;
using System.Collections.Generic;

namespace gg {
    class Program {

        static void Main(string[] args) {
            
            int N = int.Parse(Console.ReadLine());
            int[] niz = new int[N];
            int[] novi_niz = new int[N];
            
            string[] s = Console.ReadLine().Split();
            for (int i = 0; i < N; i++)
            {
                niz[i] = int.Parse(s[i]);
            }
            int Q = int.Parse(Console.ReadLine());
            bool[] tacno = new bool[Q];
            int[] l = new int[Q];
            int[] r = new int[Q];
            for (int i = 0; i < Q; i++) {
                s = Console.ReadLine().Split();  
                l[i] = int.Parse(s[0]);
                r[i] = int.Parse(s[1]);
                tacno[i] = true;
            }
            int broj = 0;
            for (int i = 0; i < Q; i++) {
                for (int k = l[i]; k < r[i]; k++) {
                    int a = l[i] - 1;
                    broj = 0;
                    if (niz[k] < niz[k - 1])
                    {
                        if (niz[k] < niz[a])
                        {
                            if (k != a + 1)
                            {
                                tacno[i] = false;
                            }
                            else
                                broj++;
                        }
                        else
                        {
                            broj++;
                        }
                    }
                    else
                    {
                        niz[k - 1] = a;
                    }
                }
                if (broj > 1) {
                    tacno[i] = false;
                }
            }
            foreach (bool x in tacno)
            {
                Console.WriteLine(x ? "DA" : "NE");
            }
            Console.ReadLine();
        }
    
    
    }

}